package main

import (
	"fmt"
	"sort"
)

type Date struct {
	D,M,Y int
}

type Person struct {
	Name string
	DateOfBirth Date
}

type ByName []Person
type ByAge []Person

func (p ByName) Less(i,j int) bool {
	return p[i].Name < p[j].Name
}

func (p ByName) Swap(i,j int) {
	p[i], p[j] = p[j], p[i]
}

func (p ByName) Len() int {
	return len(p)
}

func (p ByAge) Less(i,j int) bool {
	return p[i].DateOfBirth.Y < p[j].DateOfBirth.Y || (p[i].DateOfBirth.Y == p[j].DateOfBirth.Y && p[i].DateOfBirth.M < p[j].DateOfBirth.M) || (p[i].DateOfBirth.Y == p[j].DateOfBirth.Y && p[i].DateOfBirth.M == p[j].DateOfBirth.M && p[i].DateOfBirth.D < p[j].DateOfBirth.D)
}

func (p ByAge) Swap(i,j int) {
	p[i], p[j] = p[j], p[i]
}

func (p ByAge) Len() int {
	return len(p)
}

func main() {
	pp := []Person {{"Boldi Paolo", Date{29, 11, 1968}},
		{"Zucchi Giovanni", Date{9, 10, 2000}},
		{"Abata Flavio", Date{2, 3, 1979}},
		{"Bertocchi Agamennone", Date{27, 8, 1987}},
	}

	sort.Sort(ByName(pp))
	fmt.Println("By name:\n", pp)
	sort.Sort(ByAge(pp))
	fmt.Println("By age:\n", pp)
	
}